#include <stdlib.h>
#include <graphics.h>
#include <conio.h>
#include <stdio.h>
#include <mem.h>
#include <string.h>
#include <alloc.h>
#include <dos.h>
#include "mouse.h"

 const char *Text[3][5] = {{"1. relace R1","Komplementarni R1","Inverzni R1","Dualni R1","Neni relace"},
			   {"2. relace R2","Komplementarni R2","Inverzni R2","Dualni R2","Neni relace"},
			   {"Vysledna relace Rv","Komplementarni Rv","Inverzni Rv","Dualni Rv","Neni relace"}
			  };

 const char *Vlast[18] = {"reflexivni","symetricka","polosymetricka",
                          "asymetricka","antisymetricka","tranzitivni",
                          "polotranzitivni","negatranzitivni","silne tranzitivni",
                          "prazdna","jednotkova","uplna",
                          "univerzalni","ekvivalence","kvaziusporadani",
                          "usporadani","linearni usporadani","bezprostredni predchazeni"};

 const char BoxSize = 18, InBox = 6, Pocr = 18, InButton = 10;
 const struct { int X;
                int Y;
              } StatusLine = {22, 466};
 const int ClickFreq = 5000, ClickDelay = 1;

 struct SVlastnosti {
  int DimX, DimY, DimX0, DimY0;
  char Tab[26][26];
  int SizeX, SizeY;
  int PocX, PocY;
  struct {
   int X, Y;
  } Selected;
  int Vlastp[18];
  int MovedX, MovedY;
  int Status;
  char Indexy[26];
 };//SVlastnosti

 class CRelace {
  public:
   char ID;
   int DimX, DimY, DimX0, DimY0;
   char Tab[26][26];
   int SizeX, SizeY;
   int PocX, PocY;
   struct {
    int X, Y;
   } Selected;
   int Vlastp[18];
   int MovedX, MovedY;
   int Status;
   char Indexy[26];
   int Changed;
   CRelace (char num);
   void Get (SVlastnosti &vlast);
   void Set (SVlastnosti vlast);
   void SetDim (int x, int y);
   void DrawPlace ();
   void DrawIndex ();
   void Fill (char mark);
   void Edit ();
   void Focus ();
   void UnFocus ();
   void Vlastnosti ();
   void DrawAll ();
   void Clear ();
   void Move (char x, char y, char mark);
   void Napis ();
   void Vynulovat ();
   void Komplementarni ();
   void Inverzni ();
   void Kvaziordinalni ();
   void Puvodni ();
 };//CRelace

 class CButton {
   int X1,X2,Y1,Y2;
   char *Text;
   char Key;
   char CountHighlited;
  public:
   CButton (int x1, int y1, int x2, int y2, char *text, char key, char ch);
   int Draw ();
   char Inside (int x, int y);
 };//CButton

 CMouse Mouse;
 int kTab = 0, bStar = 0, kLeft = 0, kRight = 0, kUp = 0, kDown = 0, bE = 0,
  bC = 0, bP = 0, bS = 0, bV = 0, bK = 0, bI = 0, bD = 0, bQ = 0, bU = 0,
  bJ = 0, bN = 0, bR = 0, bM = 0, bO = 0, bF1 = 0, bEsc = 0;
 CRelace Relace[3] = {0,1,2};
 CButton *Buttons[3][6];
 SVlastnosti pomVlast[2];
 char selected, selected0;
 char GraphOn = 0;
 int ScrollPos = 221;
 char ScrollDif = -1;
 char Copying = 0;
 char *Clipboard = '\0';

void ErrorMsg (const char *text)
{
 if (GraphOn) { closegraph (); GraphOn = 0; }//if
 printf (text);
 exit (1);
}//ErrorMsg

void StatusLineWrite (int poz1, char *text1, int poz2, char *text2, int poz3, char *text3)
{
 setfillstyle (SOLID_FILL, DARKGRAY);
 bar (2, 462, 637, 477);
 setcolor (WHITE);
 outtextxy (StatusLine.X + poz1, StatusLine.Y, text1);
 outtextxy (StatusLine.X + poz2, StatusLine.Y, text2);
 outtextxy (StatusLine.X + poz3, StatusLine.Y, text3);
}//StatusLineWrite

void Beep (int freq, int del)
{
 sound (freq); delay (del); nosound ();
}//Beep

void CRelace::SetDim (int x, int y)
{
 char wasTab = 1;
 if (Tab == NULL) wasTab = 0;
 else Get (pomVlast[0]);
 int pomx = (x < DimX) ? x : DimX, pomy = (y < DimY) ? y : DimY;
 for (int j = 0; j < y; j++)
  for (int k = 0; k < x; k++)
   if ((wasTab) && (j < pomy) && (k < pomx)) Tab[j][k] = pomVlast[0].Tab[j][k];
   else Tab[j][k] = 0;
 DimX = x; DimY = y;
 DimX0 = (x < 10) ? x : 9, DimY0 = (y < 10) ? y : 9;
 SizeX = 22 + DimX0 * BoxSize;
 SizeY = 22 + DimY0 * BoxSize;
 PocX = (640 - 3 * SizeX) / 4;
 PocY = (640 - 3 * SizeY) / 4;
 Selected.X = Selected.Y = 0;
 MovedX = MovedY = 0;
 Status = 0;
 for (int l = 0; l < 26; l++) Indexy[l] = l + 'a';
}//SetDim

CRelace::CRelace (char num)
{
 ID = num;
 Changed = 0;
 DimX = DimY = 9;
 SetDim (9,9);
}//CRelace

void CRelace::Get (SVlastnosti &vlast)
{
 vlast.DimX = DimX; vlast.DimY = DimY; vlast.DimX0 = DimX0; vlast.DimY0 = DimY0;
 for (int l = 0; l < DimY; l++)
   for (int m = 0; m < DimX; m++)
    vlast.Tab[l][m] = Tab[l][m];
 vlast.SizeX = SizeX; vlast.SizeY = SizeY;
 vlast.PocX = PocX; vlast.PocY = PocY;
 vlast.Selected.X = Selected.X; vlast.Selected.Y = Selected.Y;
 for (int i = 0; i < 18; i++)
  vlast.Vlastp[i] = Vlastp[i];
 vlast.MovedX = MovedX; vlast.MovedY = MovedY;
 vlast.Status = Status;
 for (int n = 0; n < 26; n++) vlast.Indexy[n] = Indexy[n];
}//Get

void CRelace::Set (SVlastnosti vlast)
{
 DimX = vlast.DimX; DimY = vlast.DimY; DimX0 = vlast.DimX0; DimY0 = vlast.DimY0;
 for (int l = 0; l < vlast.DimY; l++)
   for (int m = 0; m < vlast.DimX; m++)
    Tab[l][m] = vlast.Tab[l][m];
 SizeX = vlast.SizeX; SizeY = vlast.SizeY;
 PocX = vlast.PocX; PocY = vlast.PocY;
 Selected.X = vlast.Selected.X; Selected.Y = vlast.Selected.Y;
 for (int i = 0; i < 18; i++)
  Vlastp[i] = vlast.Vlastp[i];
 MovedX = vlast.MovedX; MovedY = vlast.MovedY;
 Status = vlast.Status;
 for (int n = 0; n < 26; n++) Indexy[n] = vlast.Indexy[n];
}//Set

void CRelace::Vlastnosti ()
{
 int ok = 1, i, j, k;
 for (int w = 0; w < 18; w++) Vlastp[w] = 0;
 if (DimX == DimY) {
  for (i = 0; i < DimX; i++)
  if (Tab[i][i] == 0) { ok = 0; break; }//if
 }//if
 else ok = 0;
 if (ok) Vlastp[0] = 1;
 ok = 1;
 for (i = 0; i < DimX; i++)
  for (j = 0; j < DimY; j++)
   if (Tab[i][j] != 0)
    if ((j < DimX) && (i < DimY)) {
     if (Tab[j][i] == 0) { ok = 0; break; }//if
    }//if
    else { ok = 0; break; }//else
 if (ok) Vlastp[1] = 1;
 ok = 0;
 for (i = 0; i < DimX; i++)
  for (j = 0; j < DimY; j++)
   if ((j < DimX) && (i < DimY)) {
    if ((Tab[i][j] != 0) && (Tab[j][i] == 0)) { ok = 1; break; }//if
   }//if
 if (ok) Vlastp[2] = 1;
 ok = 1;
 for (i = 0; i < DimX; i++)
  for (j = 0; j < DimY; j++)
   if (Tab[i][j] != 0)
    if ((j < DimX) && (i < DimY)) {
     if (Tab[j][i] != 0) { ok = 0; break; }//if
    }//if
    else { ok = 0; break; }//else
 if (ok) Vlastp[3] = 1;
 ok = 1;
 for (i = 0; i < DimX; i++)
  for (j = 0; j < DimY; j++)
   if (Tab[i][j] != 0)
    if ((j < DimX) && (i < DimY)) {
     if (Tab[j][i] != 0) if (i != j) { ok = 0; break; }//if
    }//if
 if (ok) Vlastp[4] = 1;
 ok = 1;
 for (i = 0; i < DimX; i++)
  for (j = 0; j < DimY; j++)
   for (k = 0; k < DimY; k++)
    if (Tab[i][j] != 0)
     if (j < DimX) {
      if (Tab[j][k] != 0)
       if (Tab[i][k] == 0) { ok = 0; break; }//if
     }//if
 if (ok) Vlastp[5] = 1;
 ok = 0;
 for (i = 0; i < DimX; i++)
  for (j = 0; j < DimY; j++)
   for (k = 0; k < DimY; k++)
    if (Tab[i][j] != 0)
     if (j < DimX) {
      if (Tab[j][k] != 0)
       if (Tab[i][k] == 0) { ok = 1; break; }//if
     }//if
 if (ok) Vlastp[6] = 1;
 ok = 1;
 for (i = 0; i < DimX; i++)
  for (j = 0; j < DimY; j++)
   for (k = 0; k < DimY; k++)
    if (Tab[i][j] == 0)
     if (j < DimX) {
      if (Tab[j][k] == 0)
       if (Tab[i][k] != 0) { ok = 0; break; }//if
     }//if
 if (ok) Vlastp[7] = 1;
 if ((Vlastp[5]) && (Vlastp[7])) Vlastp[8] = 1;
 ok = 1;
 for (i = 0; i < DimX; i++)
  for (j = 0; j < DimY; j++)
   if (Tab[i][j] != 0) { ok = 0; break; }//if
 if (ok) Vlastp[9] = 1;
 ok = 1;
 for (i = 0; i < DimX; i++)
  for (j = 0; j < DimY; j++)
   if (Tab[i][j] != 0) if (i != j) { ok = 0; break; }//if
 if ((ok) && (Vlastp[0])) Vlastp[10] = 1;
 ok = 1;
 for (i = 0; i < DimX; i++)
  for (j = 0; j < DimY; j++)
   if (Tab[i][j] == 0)
    if ((j < DimX) && (i < DimY)) {
     if (Tab[j][i] == 0) { ok = 0; break; }//if
    }//if
    else { ok = 0; break; }//else
 if (ok) Vlastp[11] = 1;
 ok = 1;
 for (i = 0; i < DimX; i++)
  for (j = 0; j < DimY; j++)
   if (Tab[i][j] == 0) { ok = 0; break; }//if
 if (ok) Vlastp[12] = 1;
 if ((Vlastp[0]) && (Vlastp[1]) && (Vlastp[5])) Vlastp[13] = 1;
 if ((Vlastp[0]) && (Vlastp[5])) Vlastp[14] = 1;
 if ((Vlastp[14]) && (Vlastp[4])) Vlastp[15] = 1;
 if ((Vlastp[15]) && (Vlastp[11])) Vlastp[16] = 1;
 /*ok = 1;
 for (i = 0; i < Relace[num].size; i++)
  for (j = 0; j < Relace[num].size; j++)
   for (k = 0; k < Relace[num].size; k++)
    if (Relace[num].Rel[i][j] == '1')
     if ((Relace[num].Rel[i][k] == '1') && (Relace[num].Rel[k][j] == '1'))
      { ok = 0; break; }//if
 if (ok) vlastp[num][17] = 1;*/
 setfillstyle (SOLID_FILL, WHITE);
 bar (447, 244, 616, 418);
 for (w = 0; w < 17; w++) {
  if ((Vlastp[w]) && (Status != 4)) setcolor (BLACK);
  else setcolor (LIGHTGRAY);
  outtextxy (455, 248 + 10 * w, Vlast[w]);
 }//for
}//Vlastnosti

void CRelace::DrawPlace ()
{
 setcolor (BLUE);
 rectangle ((ID + 1) * PocX + ID * SizeX, PocY, (ID + 1) * PocX + (ID + 1) * SizeX, SizeY + PocY);
 rectangle ((ID + 1) * PocX + ID * SizeX + 1, PocY + 1, (ID + 1) * PocX + (ID + 1) * SizeX - 1, SizeY + PocY - 1);
 setfillstyle (SOLID_FILL, WHITE);
 bar ((ID + 1) * PocX + ID * SizeX + 2, PocY + 2, (ID + 1) * PocX + (ID + 1) * SizeX - 2, SizeY + PocY - 2);
 setcolor (BLACK);
 line ((ID + 1) * PocX + Pocr + ID * SizeX, PocY + 2, (ID + 1) * PocX + Pocr + ID * SizeX, SizeY + PocY - 2);
 line ((ID + 1) * PocX + ID * SizeX + 2, PocY + Pocr, (ID + 1) * PocX + (ID + 1) * SizeX - 2, PocY + Pocr);
}//DrawPlace

void CRelace::DrawIndex ()
{
 setcolor (BLACK);
 setfillstyle (SOLID_FILL, WHITE);
 bar ((ID + 1) * PocX + 2 + Pocr + ID * SizeX, PocY + 2, (ID + 1) * PocX + 2 + Pocr + ID * SizeX + BoxSize * DimX0, PocY + 2 + BoxSize - 4);
 bar ((ID + 1) * PocX + 2 + ID * SizeX, PocY + 2 + Pocr, (ID + 1) * PocX + 2 + ID * SizeX + BoxSize - 4, PocY + 2 + Pocr + BoxSize * DimY0);
 char *pom = '\0';
 for (int i = 0; i < DimX0; i++) {
  *pom = Indexy[i + MovedX]; *(pom + 1) = '\0';
  outtextxy ((ID + 1) * PocX + 2 + Pocr + InBox + ID * SizeX + i * BoxSize, PocY + 2 + InBox, pom);
 }//for
 for (int j = 0; j < DimY0; j++) {
  *pom = Indexy[j + MovedY]; *(pom + 1) = '\0';
  outtextxy ((ID + 1) * PocX + 2 + InBox + ID * SizeX, PocY + 2 + Pocr + InBox + j * BoxSize, pom);
 }//for
}//DrawIndex

void CRelace::Fill (char mark)
{
 setfillstyle (SOLID_FILL, WHITE);
 setcolor (BLACK);
 bar ((ID + 1) * PocX + Pocr + ID * SizeX + 2, PocY + Pocr + 2, (ID + 1) * PocX + (ID + 1) * SizeX - 2, SizeY + PocY - 2);
 for (int k = 0; k <= DimX0; k++) {
  line ((ID + 1) * PocX + Pocr + ID * SizeX + 2 + BoxSize * k, PocY + Pocr + 2, (ID + 1) * PocX + Pocr + ID * SizeX + 2 + BoxSize * k, PocY + Pocr + 2 + DimY0 * BoxSize);
 }//for
 for (int l = 0; l <= DimY0; l++) {
  line ((ID + 1) * PocX + Pocr + ID * SizeX + 2, PocY + Pocr + 2 + BoxSize * l, (ID + 1) * PocX + Pocr + ID * SizeX + 2 + DimX0 * BoxSize, PocY + Pocr + 2 + BoxSize * l);
 }//for
 if (mark)
  if ((Selected.X >= MovedX) && (Selected.X < MovedX + 9) &&
   (Selected.Y >= MovedY) && (Selected.Y < MovedY + 9)) {
   setfillstyle (SOLID_FILL, YELLOW);
   bar ((ID + 1) * PocX + 2 + Pocr + ID * SizeX + BoxSize * (Selected.X - MovedX) + 1, PocY + 2 + Pocr + BoxSize * (Selected.Y - MovedY) + 1, (ID + 1) * PocX + 2 + Pocr + ID * SizeX + BoxSize * (Selected.X - MovedX) + BoxSize - 1, PocY + 2 + Pocr + BoxSize * (Selected.Y - MovedY) + BoxSize - 1);
  }//if
 char *pom = '\0';
 for (int i = 0; i < DimY0; i++)
  for (int j = 0; j < DimX0; j++) {
   *pom = Tab[i + MovedY][j + MovedX] + '0'; *(pom + 1) = '\0';
   outtextxy ((ID + 1) * PocX + 2 + Pocr + InBox + ID * SizeX + j * BoxSize, PocY + 2 + Pocr + InBox + i * BoxSize, pom);
  }//for
 Vlastnosti ();
 Napis ();
}//Fill

void CRelace::Edit ()
{
 setcolor (RED);
 rectangle ((ID + 1) * PocX + ID * SizeX - 2, PocY - 2, (ID + 1) * PocX + (ID + 1) * SizeX + 2, SizeY + PocY + 2);
 rectangle ((ID + 1) * PocX + ID * SizeX - 1, PocY - 1, (ID + 1) * PocX + (ID + 1) * SizeX + 1, SizeY + PocY + 1);
 rectangle ((ID + 1) * PocX + ID * SizeX, PocY, (ID + 1) * PocX + (ID + 1) * SizeX, SizeY + PocY);
 rectangle ((ID + 1) * PocX + ID * SizeX + 1, PocY + 1, (ID + 1) * PocX + (ID + 1) * SizeX - 1, SizeY + PocY - 1);
 SVlastnosti pomvlast;
 Relace[selected].Get (pomvlast);
 int key, nula;
 int kLeft = 0, kRight = 0, kUp = 0, kDown = 0, number = 0;
 char *pom = '\0';
 do {
  fflush (stdin);
  nula = 0;
  key = getch ();
  if (!key) { nula = 1; key = getch (); }//if
  switch (key) { case 75 : if (nula) kLeft++; break;
                 case 77 : if (nula) kRight++; break;
                 case 72 : if (nula) kUp++; break;
                 case 80 : if (nula) kDown++; break;
	       }//switch
  if ((key > 47) && (key < 50)) number++;
  if ((Selected.X >= MovedX) && (Selected.X < MovedX + 9) &&
   (Selected.Y >= MovedY) && (Selected.Y < MovedY + 9)) {
   setfillstyle (SOLID_FILL, WHITE);
   bar ((ID + 1) * PocX + 2 + Pocr + ID * SizeX + BoxSize * (Selected.X - MovedX) + 1, PocY + 2 + Pocr + BoxSize * (Selected.Y - MovedY) + 1, (ID + 1) * PocX + 2 + Pocr + ID * SizeX + BoxSize * (Selected.X - MovedX) + BoxSize - 1, PocY + 2 + Pocr + BoxSize * (Selected.Y - MovedY) + BoxSize - 1);
   setcolor (BLACK);
   *pom = Tab[Selected.Y][Selected.X] + '0'; *(pom + 1) = '\0';
   outtextxy ((ID + 1) * PocX + 2 + Pocr + InBox + ID * SizeX + (Selected.X - MovedX) * BoxSize, PocY + 2 + Pocr + InBox + (Selected.Y - MovedY) * BoxSize, pom);
  }//if
  if (kLeft) { kLeft--; if (Selected.X > 0) Selected.X--; }//if
  if (kRight) { kRight--; if (Selected.X < DimX - 1) Selected.X++; }//if
  if (kUp) { kUp--; if (Selected.Y > 0) Selected.Y--; }//if
  if (kDown) { kDown--; if (Selected.Y < DimY - 1) Selected.Y++; }//if
  if (Selected.X < MovedX) Move (-1, 0, 0);
  if (Selected.X >= MovedX + 9) Move (1, 0, 0);
  if (Selected.Y < MovedY) Move (0, -1, 0);
  if (Selected.Y >= MovedY + 9) Move (0, 1, 0);
  if (number) {
   number--;
   Tab[Selected.Y][Selected.X] = key - '0';
  }//if
  if ((Selected.X >= MovedX) && (Selected.X < MovedX + 9) &&
   (Selected.Y >= MovedY) && (Selected.Y < MovedY + 9)) {
   setfillstyle (SOLID_FILL, YELLOW);
   bar ((ID + 1) * PocX + 2 + Pocr + ID * SizeX + BoxSize * (Selected.X - MovedX) + 1, PocY + 2 + Pocr + BoxSize * (Selected.Y - MovedY) + 1, (ID + 1) * PocX + 2 + Pocr + ID * SizeX + BoxSize * (Selected.X - MovedX) + BoxSize - 1, PocY + 2 + Pocr + BoxSize * (Selected.Y - MovedY) + BoxSize - 1);
   setcolor (BLACK);
   *pom = '\0';
   *pom = Tab[Selected.Y][Selected.X] + '0'; *(pom + 1) = '\0';
   outtextxy ((ID + 1) * PocX + 2 + Pocr + InBox + ID * SizeX + (Selected.X - MovedX) * BoxSize, PocY + 2 + Pocr + InBox + (Selected.Y - MovedY) * BoxSize, pom);
  }//if
  if (key == 27) {
   Relace[selected].Set (pomvlast);
   DrawIndex (); Fill (1);
  }//if
 } while ((key != 27) && (key != 13));
 setcolor (MAGENTA);
 rectangle ((ID + 1) * PocX + ID * SizeX - 2, PocY - 2, (ID + 1) * PocX + (ID + 1) * SizeX + 2, SizeY + PocY + 2);
 rectangle ((ID + 1) * PocX + ID * SizeX - 1, PocY - 1, (ID + 1) * PocX + (ID + 1) * SizeX + 1, SizeY + PocY + 1);
 rectangle ((ID + 1) * PocX + ID * SizeX, PocY, (ID + 1) * PocX + (ID + 1) * SizeX, SizeY + PocY);
 rectangle ((ID + 1) * PocX + ID * SizeX + 1, PocY + 1, (ID + 1) * PocX + (ID + 1) * SizeX - 1, SizeY + PocY - 1);
 Vlastnosti ();
}//Edit

void CRelace::Focus ()
{
 Relace[selected0].UnFocus ();
 setcolor (MAGENTA);
 rectangle ((ID + 1) * PocX + ID * SizeX - 2, PocY - 2, (ID + 1) * PocX + (ID + 1) * SizeX + 2, SizeY + PocY + 2);
 rectangle ((ID + 1) * PocX + ID * SizeX - 1, PocY - 1, (ID + 1) * PocX + (ID + 1) * SizeX + 1, SizeY + PocY + 1);
 rectangle ((ID + 1) * PocX + ID * SizeX, PocY, (ID + 1) * PocX + (ID + 1) * SizeX, SizeY + PocY);
 rectangle ((ID + 1) * PocX + ID * SizeX + 1, PocY + 1, (ID + 1) * PocX + (ID + 1) * SizeX - 1, SizeY + PocY - 1);
 Vlastnosti ();
}//Focus

void CRelace::UnFocus ()
{
 setcolor (GREEN);
 rectangle ((ID + 1) * PocX + ID * SizeX - 2, PocY - 2, (ID + 1) * PocX + (ID + 1) * SizeX + 2, SizeY + PocY + 2);
 rectangle ((ID + 1) * PocX + ID * SizeX - 1, PocY - 1, (ID + 1) * PocX + (ID + 1) * SizeX + 1, SizeY + PocY + 1);
 setcolor (BLUE);
 rectangle ((ID + 1) * PocX + ID * SizeX, PocY, (ID + 1) * PocX + (ID + 1) * SizeX, SizeY + PocY);
 rectangle ((ID + 1) * PocX + ID * SizeX + 1, PocY + 1, (ID + 1) * PocX + (ID + 1) * SizeX - 1, SizeY + PocY - 1);
}//UnFocus

void CRelace::Clear ()
{
 setfillstyle (SOLID_FILL, GREEN);
 bar ((ID + 1) * 22 + ID * 184 - 2, 22 - 2, (ID + 1) * 22 + (ID + 1) * 184 + 2, 184 + 22 + 2);
}//Clear

void CRelace::DrawAll ()
{
 Clear (); DrawPlace (); DrawIndex (); Fill (1);
}//DrawAll

void CRelace::Move (char x, char y, char mark)
{
 if ((x != 0) && (DimX > 9)) {
  if ((x == -1) && (MovedX > 0)) MovedX--;
  if ((x == 1) && (MovedX < DimX - DimX0)) MovedX++;
 }//if
 if ((y != 0) && (DimY > 9)) {
  if ((y == -1) && (MovedY > 0)) MovedY--;
  if ((y == 1) && (MovedY < DimY - DimY0)) MovedY++;
 }//if
 DrawIndex ();
 Fill (mark);
}//Move

void CRelace::Napis ()
{
 int dx;
 setcolor (BLACK);
 setfillstyle (SOLID_FILL, GREEN);
 switch (ID) { case 0 : bar (22, 215, 200, 235); dx = 114; break;
               case 1 : bar (228, 215, 412, 235); dx = 320; break;
               case 2 : bar (434, 215, 618, 235); dx = 526;
             }//switch
 outtextxy (dx - textwidth (Text[ID][Status]) / 2, 215, Text[ID][Status]);
 char dim[8] = {' ',' ',' ','x',' ',' ',' ','\0'};
 int dimx[2] = {DimX / 10, DimX % 10}, dimy[2] = {DimY / 10, DimY % 10};
 if (dimy[0] != 0) dim[0] = dimy[0] + '0'; else dim[0] = ' ';
 dim[1] = dimy[1] + '0';
 if (dimx[0] != 0) dim[5] = dimx[0] + '0'; else dim[5] = ' ';
 dim[6] = dimx[1] + '0';
 outtextxy (dx - textwidth (dim) / 2, 225, dim);
}//Napis

void CRelace::Vynulovat ()
{
 StatusLineWrite (0,"Potvrzeni akce: Vynulovat relaci? (a/n)",0,"",0,"");
 Beep (400, 100);
 int key;
 do {
  fflush (stdin);
  key = getch ();
  if (key == 'a') {
   for (int j = 0; j < DimY; j++)
    for (int k = 0; k < DimX; k++)
     Tab[j][k] = 0;
   Status = 0;
   Fill (1);
  }//if
 } while ((key != 'a') && (key != 'n'));
 StatusLineWrite (0,"",0,"",0,"");
}//FillAll

void CRelace::Komplementarni ()
{
 if (Status != 4) {
  if (!Changed) { Relace[selected].Get (pomVlast[1]); Changed = 1; }//if
  for (int i = 0; i < DimY; i++)
   for (int j = 0; j < DimX; j++)
    Tab[i][j] = !Tab[i][j];
  switch (Status) { case 0 : Status = 1; break;
                    case 1 : Status = 0; break;
                    case 2 : Status = 3; break;
                    case 3 : Status = 2; break;
                  }//switch
  Fill (1);
 }//if
 else {
  StatusLineWrite (0,"Nelze: V poli neni relace",0,"",0,"");
  Beep (400, 100);
  delay (2000);
  StatusLineWrite (0,"",0,"",0,"");
 }//else
}//Komplementarni

void CRelace::Inverzni ()
{
 if (Status != 4) {
  if (!Changed) { Relace[selected].Get (pomVlast[1]); Changed = 1; }//if
  SVlastnosti pomvlast;
  Get (pomvlast);
  int pomi;
  pomi = DimX; DimX = DimY; DimY = pomi;
  pomi = DimX0; DimX0 = DimY0; DimY0 = pomi;
  pomi = SizeX; SizeX = SizeY; SizeY = pomi;
  pomi = PocX; PocX = PocY; PocY = pomi;
  pomi = Selected.X; Selected.X = Selected.Y; Selected.Y = pomi;
  pomi = MovedX; MovedX = MovedY; MovedY = pomi;
  for (int i = 0; i < pomvlast.DimY; i++)
   for (int j = 0; j < pomvlast.DimX; j++)
    Tab[j][i] = pomvlast.Tab[i][j];
  switch (Status) { case 0 : Status = 2; break;
                    case 1 : Status = 3; break;
                    case 2 : Status = 0; break;
                    case 3 : Status = 1; break;
                  }//switch
  DrawAll ();
  Focus ();
 }//if
 else {
  StatusLineWrite (0,"Nelze: V poli neni relace",0,"",0,"");
  Beep (400, 100);
  delay (2000);
  StatusLineWrite (0,"",0,"",0,"");
 }//else
}//Inverzni

void CRelace::Kvaziordinalni ()
{
 if (Status != 4) {
  if (DimX == DimY) {
   int hodn[2][26], i, j, index[2];
   char kvaz[27], nula, exist;
   for (i = 0; i < DimX; i++) kvaz[i] = '?'; kvaz[DimX] = '\0';
   index[0] = 0; index[1] = DimX - 1;
   for (i = 0; i < 2; i++) for (j = 0; j < DimX; j++) hodn[i][j] = 0;
   do {
    for (j = 0; j < DimX; j++)
     if (hodn[0][j] != -1) {
      hodn[0][j] = 0;
      for (i = 0; i < DimY; i++)
       if (hodn[1][i] != -1) hodn[0][j] += !!Tab[i][j];
     }//if
    for (i = 0; i < DimY; i++)
     if (hodn[1][i] != -1) {
      hodn[1][i] = 0;
      for (j = 0; j < DimX; j++)
       if (hodn[0][j] != -1) hodn[1][i] += !!Tab[i][j];
     }//if
    nula = 0;
    for (j = 0; j < DimX; j++)
     if (hodn[0][j] == 0) {
      nula++;
      hodn[0][j] = hodn[1][j] = -1;
      kvaz[index[0]] = j + 'a';
      index[0]++;
     }//if
    if ((!nula) || (nula == DimX)) break;
    nula = 0;
    for (i = 0; i < DimY; i++)
     if (hodn[1][i] == 0) {
      nula++;
      hodn[1][i] = hodn[0][i] = -1;
      kvaz[index[1]] = i + 'a';
      index[1]--;
     }//if
    if (!nula) break;
    exist = 0;
    for (i = 0; i < DimY; i++) if (hodn[1][i] != -1) exist = 1;
   } while (exist);
   int key = 0;
   if (nula) {
    StatusLineWrite (0,"Hodnoty KF: [",110,kvaz,116 + DimX * 8,
     "]. Stiskni lib. klavesu ...");
    do {
     fflush (stdin);
     key = getch ();
    } while (key == 0);
   }//if
   else {
    StatusLineWrite (0,"Hodnoty KF: [",110,kvaz,116 + DimX * 8,
     "], Relace obsahuje cyklus. Editovat ? (a/n)");
    Beep (400, 100);
    do {
     fflush (stdin);
     key = getch ();
     if (key == 'a') Relace[selected].Edit ();
    } while ((key != 'a') && (key != 'n'));
   }//else
   StatusLineWrite (0,"",0,"",0,"");
  }//if
  else {
   StatusLineWrite (0,"Nelze : Relace neni relaci na mnozine",0,"",0,"");
   Beep (400, 100);
   delay (2000);
   StatusLineWrite (0,"",0,"",0,"");
  }//else
 }//if
 else {
  StatusLineWrite (0,"Nelze: V poli neni relace",0,"",0,"");
  Beep (400, 100);
  delay (2000);
  StatusLineWrite (0,"",0,"",0,"");
 }//else
}//Kvaziordinalni

void CRelace::Puvodni ()
{
 if (Changed) { Relace[selected].Set (pomVlast[1]); Changed = 0; }//if
 DrawAll ();
 Focus ();
}//Puvodni

CButton::CButton (int x1, int y1, int x2, int y2, char *text, char key, char ch)
{
 X1 = x1; X2 = x2; Y1 = y1; Y2 = y2; Text = text; Key = key;
 CountHighlited = ch;
}//CButton

int CButton::Draw ()
{
 char targstr[100] = "\0", pomstr[100];
 int dif = 0;
 setcolor (BLACK);
 if (X2 == 0) X2 = X1 + textwidth (Text) + 2 * InButton;
 if (Y2 == 0) Y2 = Y1 + textheight (Text) + 2 * InButton;
 rectangle (X1, Y1, X2, Y2);
 setfillstyle (SOLID_FILL, LIGHTGRAY);
 bar (X1 + 1, Y1 + 1, X2 - 1, Y2 - 1);
 memcpy (targstr, strchr (Text, Key), CountHighlited);
 *(targstr + CountHighlited) = '\0';
 if (targstr != NULL) {
  dif = strchr (Text, Key) - Text;
  memcpy (pomstr, Text, dif);
  *(pomstr + dif) = '\0';
  dif = textwidth (pomstr);
 }//if
 setcolor (BLACK);
 int deltax = ((X2 - X1) - textwidth (Text)) / 2;
 int deltay = ((Y2 - Y1) - textheight (Text)) / 2;
 outtextxy (X1 + deltax, Y1 + deltay, Text);
 setcolor (WHITE);
 outtextxy (X1 + deltax + dif, Y1 + deltay, targstr);
 return X2 - X1;
}//Draw

char CButton::Inside (int x, int y)
{
 if ((x >= X1) && (x <= X2) && (y >= Y1) && (y <= Y2)) return 1;
 else return 0;
}//Inside

void ScrollTitle ()
{
 setcolor (BLUE);
 outtextxy (ScrollPos,7,"* * *  R E L A C E  * * *");
 ScrollPos += ScrollDif;
 setcolor (LIGHTRED);
 outtextxy (ScrollPos,7,"* * *  R E L A C E  * * *");
 if ((ScrollPos == 2) || (ScrollPos == 436)) ScrollDif = -ScrollDif;
}//ScrollTitle

void DrawMain ()
{
 setfillstyle (SOLID_FILL, GREEN);
 bar (0, 0, 639, 479);
 setfillstyle (SOLID_FILL, BLUE);
 bar (2, 2, 637, 17);
 ScrollTitle ();
 selected = selected0 = 0;
 for (int i = 0; i < 3; i++)
  Relace[i].DrawAll ();
 Relace[selected].Focus ();
 setcolor (BLACK);
 outtextxy (423 - textwidth ("=") / 2, 215, "=");
 outtextxy (217 - textwidth ("op.") / 2, 215, "op.");
 outtextxy (455, 427, "Schranka:");
 setcolor (YELLOW);
 rectangle (445, 242, 618, 420);
 rectangle (446, 243, 617, 419);
 setcolor (WHITE);
 rectangle (445,442,618,458);
 setcolor (LIGHTCYAN);
 outtextxy (465, 447, "Jan Outrata, 1999");
 setfillstyle (SOLID_FILL, DARKGRAY);
 bar (2, 462, 637, 477);
 Mouse.SetHRange (22,438);
 Mouse.SetVRange (250,458);
 Mouse.SetPos (22,250);
}//DrawMain

void DrawButtons ()
{
 int buty = 29, difbuty = 5, difbutx = 10, poc1 = 22, poc2, poc3;
 static CButton Button1 (poc1, 250 + buty + difbuty, 0, 0, "Kopirovat (C)", 'C', 1);
 int maxbutx = Button1.Draw ();
 Buttons[0][1] = &Button1;
 static CButton aButton1[5] = {
  CButton (poc1, 250, poc1 + maxbutx, 0, "Editovat", 'E', 1),
  CButton (poc1, 250 + 2 * (buty + difbuty), poc1 + maxbutx, 0, "Prilepit", 'P', 1),
  CButton (poc1, 250 + 3 * (buty + difbuty), poc1 + maxbutx, 0, "Smazat", 'S', 1),
  CButton (poc1, 250 + 4 * (buty + difbuty), poc1 + maxbutx, 0, "R1<->R2 (V)", 'V', 1),
  CButton (poc1, 250 + 5 * (buty + difbuty) + 2 * difbuty, poc1 + maxbutx, 0, "Rozmer (*)", '*', 1)};
 poc2 = poc1 + maxbutx + difbutx;
 static CButton Button2 (poc2, 250 + 3 * (buty + difbuty), 0, 0, "Kvaziordinalni (Q)", 'Q', 1);
 maxbutx = Button2.Draw ();
 Buttons[1][3] = &Button2;
 static CButton aButton2[5] = {
  CButton (poc2, 250, poc2 + maxbutx, 0, "Komplementarni", 'K', 1),
  CButton (poc2, 250 + buty + difbuty, poc2 + maxbutx, 0, "Inverzni", 'I', 1),
  CButton (poc2, 250 + 2 * (buty + difbuty), poc2 + maxbutx, 0, "Dualni", 'D', 1),
  CButton (poc2, 250 + 4 * (buty + difbuty), poc2 + maxbutx, 0, "Puvodni", 'u', 1),
  CButton (poc2, 250 + 5 * (buty + difbuty) + 2 * difbuty, poc2 + maxbutx, 0, "Napoveda (F1)", 'F', 2)};
 poc3 = poc2 + maxbutx + difbutx;
 static CButton Button3 (poc3, 250 + 3 * (buty + difbuty), 0, 0, "Sym. rozdil", 'm', 1);
 maxbutx = Button3.Draw ();
 Buttons[2][3] = &Button3;
 static CButton aButton3[5] = {
  CButton (poc3, 250, poc3 + maxbutx, 0, "Sjednoceni", 'j', 1),
  CButton (poc3, 250 + buty + difbuty, poc3 + maxbutx, 0, "Prunik", 'n', 1),
  CButton (poc3, 250 + 2 * (buty + difbuty), poc3 + maxbutx, 0, "Rozdil", 'R', 1),
  CButton (poc3, 250 + 4 * (buty + difbuty), poc3 + maxbutx, 0, "Kompozice", 'o', 1),
  CButton (poc3, 250 + 5 * (buty + difbuty) + 2 * difbuty, poc3 + maxbutx, 0, "Konec (Esc)", 'E', 3)};
 for (int i = 0; i < 5; i++) {
  aButton1[i].Draw (); aButton2[i].Draw (); aButton3[i].Draw ();
 }//for
 Buttons[0][0] = &aButton1[0];
 Buttons[0][2] = &aButton1[1];
 Buttons[0][3] = &aButton1[2];
 Buttons[0][4] = &aButton1[3];
 Buttons[0][5] = &aButton1[4];
 Buttons[1][0] = &aButton2[0];
 Buttons[1][1] = &aButton2[1];
 Buttons[1][2] = &aButton2[2];
 Buttons[1][4] = &aButton2[3];
 Buttons[1][5] = &aButton2[4];
 Buttons[2][0] = &aButton3[0];
 Buttons[2][1] = &aButton3[1];
 Buttons[2][2] = &aButton3[2];
 Buttons[2][4] = &aButton3[3];
 Buttons[2][5] = &aButton3[4];
}//DrawButtons

void SetDimension ()
{
 int DX = 100, DY = 55;
 int Startx = (184 / 2) + (selected + 1) * 22 + selected * 184 - (DX / 2);
 int Starty = (184 / 2) + 22 - (DY / 2);
 setcolor (BLUE);
 setfillstyle (SOLID_FILL, WHITE);
 rectangle (Startx, Starty, Startx + DX, Starty + DY);
 rectangle (Startx + 1, Starty + 1, Startx + DX - 1, Starty + DY - 1);
 bar (Startx + 2, Starty + 2, Startx + DX - 2, Starty + DY - 2);
 setcolor (BLACK);
 outtextxy (84 + selected * (22 + 184), Starty + 12, "Rozmer :");
 int key;
 int pos = (184 / 2) + (selected + 1) * 22 + selected * 184 - 33, pos0 = pos;
 outtextxy (pos + 20, Starty + 32, " x ");
 rectangle (pos - 5, Starty + 27, pos + 71, Starty + 43);
 char numstr[2] = {'0','\0'}, rad;
 int RX[2] = {0,0}, RY[2] = {0,0};
 do {
  fflush (stdin);
  key = getch ();
  if ((pos == pos0) || (pos == pos0 + 50)) rad = 1; else rad = 0;
  if ((key == 8) && (pos > pos0)) {
   if (pos == pos0 + 50) pos -= 40; else pos -= 10;
   bar (pos, Starty + 32, pos + 8, Starty + 40);
   if (pos < pos0 + 30) RX[rad] = 0; else RY[rad] = 0;
  }//if
  if (pos < pos0 + 70) {
   if ((key > 47) && (key < 58)) {
    numstr[0] = key;
    outtextxy (pos, Starty + 32, numstr);
    pos += 10;
    if (pos < pos0 + 30) RX[rad] = key - 48; else RY[rad] = key - 48;
   }//if
   if ((key == ' ') && ((pos ==  pos0) || (pos == pos0 + 50))) {
    outtextxy (pos, Starty + 32, "0");
    pos += 10;
    if (pos < pos0 + 30) RX[rad] = 0; else RY[rad] = 0;
   }//if
  }//if
  if (pos == pos0 + 20) pos += 30;
  if (key == 13) {
   int x = RX[1] * 10 + RX[0], y = RY[1] * 10 + RY[0];
   if (x < 1) x = 1; if (x > 26) x = 26;
   if (y < 1) y = 1; if (y > 26) y = 26;
   Relace[selected].SetDim (y, x);
  }//if
 } while ((key != 27) && (key != 13));
 Relace[selected].Clear ();
 Relace[selected].DrawAll ();
 Relace[selected].Focus ();
}//SetDimension

void Copy ()
{
 Relace[selected].Get (pomVlast[0]);
 Copying = 1;
 switch (selected) { case 0 : Clipboard = "R1"; break;
                     case 1 : Clipboard = "R2"; break;
                     case 2 : Clipboard = "Rv";
                   }//switch
 setcolor (BLACK);
 setfillstyle (SOLID_FILL, GREEN);
 bar (530, 427, 550, 441);
 outtextxy (530, 427, Clipboard);
}//Copy

void Paste ()
{
 if ((Relace[selected].DimX != pomVlast[0].DimX) ||
  (Relace[selected].DimY != pomVlast[0].DimY)) {
  StatusLineWrite (0,"Relace nemaji stejne rozmery. Zmenit rozmery cilove relace? (a/n)",0,"",0,"");
  Beep (400, 100);
  int key;
  do {
   fflush (stdin);
   key = getch ();
   if (key == 'a') {
    Relace[selected].Set (pomVlast[0]);
    Relace[selected].DrawAll ();
    Relace[selected].Focus ();
   }//if
  } while ((key != 'a') && (key != 'n'));
  StatusLineWrite (0,"",0,"",0,"");
 }//if
 else {
  Relace[selected].Set (pomVlast[0]);
  Relace[selected].DrawAll ();
  Relace[selected].Focus ();
 }//else
}//Paste

void Exchange ()
{
 SVlastnosti pomvlast[2];
 Relace[0].Get (pomvlast[0]);
 Relace[1].Get (pomvlast[1]);
 Relace[0].Set (pomvlast[1]);
 Relace[1].Set (pomvlast[0]);
 Relace[0].DrawAll ();
 Relace[1].DrawAll ();
 Relace[selected].Focus ();
}//Exchange

void Sjednoceni ()
{
 int pomx = Relace[0].DimX, pomy = Relace[0].DimY;
 if ((pomx == Relace[1].DimX) && (pomy == Relace[1].DimY)) {
  if (!Relace[2].Changed) {
   Relace[2].Get (pomVlast[1]); Relace[2].Changed = 1;
  }//if
  Relace[2].SetDim (pomx, pomy);
  char jerel = 1;
  for (int i = 0; i < pomy; i++)
   for (int j = 0; j < pomx; j++) {
    Relace[2].Tab[i][j] = Relace[0].Tab[i][j] + Relace[1].Tab[i][j];
    if (Relace[2].Tab[i][j] > 1) jerel = 0;
   }//for
  if (!jerel) Relace[2].Status = 4; else Relace[2].Status = 0;
  Relace[2].DrawAll ();
  selected = 2;
  Relace[2].Focus ();
 }//if
 else {
  StatusLineWrite (0,"Nelze : Relace nejsou na stejnych mnozinach.",0,"",0,"");
  Beep (400, 100);
  delay (2000);
  StatusLineWrite (0,"",0,"",0,"");
 }//else
}//Sjednoceni

void Prunik ()
{
 int pomx = Relace[0].DimX, pomy = Relace[0].DimY;
 if ((pomx == Relace[1].DimX) && (pomy == Relace[1].DimY)) {
  if (!Relace[2].Changed) {
   Relace[2].Get (pomVlast[1]); Relace[2].Changed = 1;
  }//if
  Relace[2].SetDim (pomx, pomy);
  for (int i = 0; i < pomy; i++)
   for (int j = 0; j < pomx; j++)
    Relace[2].Tab[i][j] = Relace[0].Tab[i][j] * Relace[1].Tab[i][j];
  Relace[2].Status = 0;
  Relace[2].DrawAll ();
  selected = 2;
  Relace[2].Focus ();
 }//if
 else {
  StatusLineWrite (0,"Nelze : Relace nejsou na stejnych mnozinach.",0,"",0,"");
  Beep (400, 100);
  delay (2000);
  StatusLineWrite (0,"",0,"",0,"");
 }//else
}//Prunik

void Rozdil ()
{
 int pomx = Relace[0].DimX, pomy = Relace[0].DimY;
 if ((pomx == Relace[1].DimX) && (pomy == Relace[1].DimY)) {
  if (!Relace[2].Changed) {
   Relace[2].Get (pomVlast[1]); Relace[2].Changed = 1;
  }//if
  Relace[2].SetDim (pomx, pomy);
  for (int i = 0; i < pomy; i++)
   for (int j = 0; j < pomx; j++)
    Relace[2].Tab[i][j] = Relace[0].Tab[i][j] * (!Relace[1].Tab[i][j]);
  Relace[2].Status = 0;
  Relace[2].DrawAll ();
  selected = 2;
  Relace[2].Focus ();
 }//if
 else {
  StatusLineWrite (0,"Nelze : Relace nejsou na stejnych mnozinach.",0,"",0,"");
  Beep (400, 100);
  delay (2000);
  StatusLineWrite (0,"",0,"",0,"");
 }//else
}//Rozdil

void SymRozdil ()
{
 int pomx = Relace[0].DimX, pomy = Relace[0].DimY;
 if ((pomx == Relace[1].DimX) && (pomy == Relace[1].DimY)) {
  if (!Relace[2].Changed) {
   Relace[2].Get (pomVlast[1]); Relace[2].Changed = 1;
  }//if
  Relace[2].SetDim (pomx, pomy);
  char jerel = 1;
  for (int i = 0; i < pomy; i++)
   for (int j = 0; j < pomx; j++) {
    Relace[2].Tab[i][j] = Relace[0].Tab[i][j] * (!Relace[1].Tab[i][j]) +
     Relace[1].Tab[i][j] * (!Relace[0].Tab[i][j]);
    if (Relace[2].Tab[i][j] > 1) jerel = 0;
   }//for
  if (!jerel) Relace[2].Status = 4; else Relace[2].Status = 0;
  Relace[2].DrawAll ();
  selected = 2;
  Relace[2].Focus ();
 }//if
 else {
  StatusLineWrite (0,"Nelze : Relace nejsou na stejnych mnozinach.",0,"",0,"");
  Beep (400, 100);
  delay (2000);
  StatusLineWrite (0,"",0,"",0,"");
 }//else
}//SymRozdil

void Kompozice ()
{
 int pomx = Relace[0].DimX, pomy = Relace[1].DimY;
 if (pomx == pomy) {
  if (!Relace[2].Changed) {
   Relace[2].Get (pomVlast[1]); Relace[2].Changed = 1;
  }//if
  Relace[2].SetDim (Relace[1].DimX, Relace[0].DimY);
  int pomsum;
  for (int i = 0; i < Relace[2].DimY; i++)
   for (int j = 0; j < Relace[2].DimX; j++) {
    pomsum = 0;
    for (int k = 0; k < pomx; k++)
     pomsum |= Relace[0].Tab[i][k] * Relace[1].Tab[k][j];
    Relace[2].Tab[i][j] = pomsum;
   }//for
  Relace[2].DrawAll ();
  selected = 2;
  Relace[2].Focus ();
 }//if
 else {
  StatusLineWrite (0,"Nelze : Prvni relace musi byt typu m/n a druha typu n/p.",0,"",0,"");
  Beep (400, 100);
  delay (2000);
  StatusLineWrite (0,"",0,"",0,"");
 }//else
}//Kompozice

void Napoveda ()
{
 Mouse.Hide ();
 setfillstyle (SOLID_FILL, BLACK);
 setcolor (BROWN);
 int x1 = 0, x2 = 639, y1 = 0, y2 = 479;
 bar (x1,y1,x2,y2);
 rectangle (x1,y1,x2,y2);
 rectangle (x1 + 2,y1 + 2,x2 - 2,y2 - 2);
 rectangle (x1 + 4,y1 + 4,x2 - 4,y2 - 4);
 rectangle (x1 + 6,y1 + 6,x2 - 6,y2 - 6);
 setcolor (YELLOW);
 settextstyle (1, 0, 2);
 outtextxy (x1 + 180, y1 + 15,"\"Horke\" klavesy a tlacitka");
 line (x1 + 175, y1 + 45, x1 + 453, y1 + 45);
 setcolor (WHITE);
 settextstyle (0, 0, 0);
 outtextxy (x1 + 30, y1 + 65,"Klavesy :");
 outtextxy (x1 + 40, y1 + 85,"Tab       Zmena \"aktivni\" relace (tj. se kterou se prave pracuje)");
 outtextxy (x1 + 40, y1 + 95,"Sipky     Posouvani tabulky aktivni relace (pokud ma rozmer vetsi nez 9)");
 outtextxy (x1 + 30, y1 + 115,"Tlacitka :");
 outtextxy (x1 + 40, y1 + 135,"pozn. : Kazde tlacitko ma svou \"horkou\" klavesu");
 outtextxy (x1 + 40, y1 + 150,"Rozmer             Zmena rozmeru aktivni relace");
 outtextxy (x1 + 200, y1 + 160,"- rozmer je urcen dvema dvoucifernymi cisly,");
 outtextxy (x1 + 200, y1 + 170,"  v pripade jednociferneho cisla se musi zadat jako");
 outtextxy (x1 + 200, y1 + 180,"  prvni cifra nula (klavesou 0 nebo mezernikem)");
 outtextxy (x1 + 40, y1 + 190,"Napoveda           Tato napoveda");
 outtextxy (x1 + 40, y1 + 200,"Konec              Ukonceni programu");
 outtextxy (x1 + 40, y1 + 215,"Editace            Editace aktivni relace");
 outtextxy (x1 + 200, y1 + 225,"- v rezimu editace se v relaci pohybuje pomoci sipek,");
 outtextxy (x1 + 200, y1 + 235,"  hodnoty se zadavaji cisly");
 outtextxy (x1 + 40, y1 + 245,"Kopirovat          Vlozeni relace do schranky pro kopirovani");
 outtextxy (x1 + 40, y1 + 255,"Prilepit           Zmena aktivni relace na relaci ve schrance");
 outtextxy (x1 + 40, y1 + 265,"Smazat             \"Vynulovani\" aktivni relace");
 outtextxy (x1 + 40, y1 + 275,"R1<->R2            Vymena prvni (R1) a druhe (R2) relace");
 outtextxy (x1 + 40, y1 + 290,"Komplementarni     Komplement k aktivni relaci");
 outtextxy (x1 + 40, y1 + 300,"Inverzni           Inverze aktivni relace");
 outtextxy (x1 + 40, y1 + 310,"Dualni             Dualni relace k aktivni relaci");
 outtextxy (x1 + 40, y1 + 320,"Kvaziordinalni     Hodnoty kvaziordinalni funkce (KF) aktivni relace");
 outtextxy (x1 + 40, y1 + 330,"Puvodni            Zpet puvodni relace pred zmenami pomoci operaci");
 outtextxy (x1 + 40, y1 + 345,"Sjednoceni         Sjednoceni relaci R1 a R2");
 outtextxy (x1 + 40, y1 + 355,"Prunik             Prunik relaci R1 a R2");
 outtextxy (x1 + 40, y1 + 365,"Rozdil             Rozdil relaci R1 a R2");
 outtextxy (x1 + 40, y1 + 375,"Sym. rozdil        Symetricky rozdil relaci R1 a R2");
 outtextxy (x1 + 40, y1 + 385,"Kompozice          Kompozice relaci R1 a R2");
 setcolor (GREEN);
 settextstyle (3, 0, 2);
 outtextxy (x1 + 30, y1 + 425,"Zpet do prostredi programu -> Esc nebo Enter");
 int key;
 do {
  fflush (stdin);
  if (kbhit ())
   key = getch ();
 } while ((key != 27) && (key != 13));
 settextstyle (0, 0, 0);
 DrawMain ();
 for (int i = 0; i < 3; i++) for (int j = 0; j < 6; j++)
  Buttons[i][j]->Draw ();
 setcolor (BLACK);
 if (Clipboard != '\0') outtextxy (530, 427, Clipboard);
 Mouse.Display ();
}//Napoveda

void MouseEvents ()
{
 Mouse.GetState ();
 if (Mouse.Left) {
  int x = Mouse.X, y = Mouse.Y;
  do Mouse.GetState (); while (Mouse.Left);
  if (Buttons[0][0]->Inside (x, y)) bE++;
  if (Buttons[0][1]->Inside (x, y)) bC++;
  if (Buttons[0][2]->Inside (x, y)) bP++;
  if (Buttons[0][3]->Inside (x, y)) bS++;
  if (Buttons[0][4]->Inside (x, y)) bV++;
  if (Buttons[0][5]->Inside (x, y)) bStar++;
  if (Buttons[1][0]->Inside (x, y)) bK++;
  if (Buttons[1][1]->Inside (x, y)) bI++;
  if (Buttons[1][2]->Inside (x, y)) bD++;
  if (Buttons[1][3]->Inside (x, y)) bQ++;
  if (Buttons[1][4]->Inside (x, y)) bU++;
  if (Buttons[1][5]->Inside (x, y)) bF1++;
  if (Buttons[2][0]->Inside (x, y)) bJ++;
  if (Buttons[2][1]->Inside (x, y)) bN++;
  if (Buttons[2][2]->Inside (x, y)) bR++;
  if (Buttons[2][3]->Inside (x, y)) bM++;
  if (Buttons[2][4]->Inside (x, y)) bO++;
  if (Buttons[2][5]->Inside (x, y)) bEsc++;
 }//if
}//MouseEvents

void EventHandler ()
{
 int key, nula;
 do {
  fflush (stdin);
  nula = 0;
  if (kbhit ()) {
   key = getch ();
   if (!key) { nula = 1; key = getch (); }//if
   selected0 = selected;
   switch (key) { case 9 : kTab++; break;
                  case '*' : bStar++; break;
                  case 75 : if (nula)  kLeft++; break;
                  case 77 : if (nula)  kRight++; break;
                  case 72 : if (nula)  kUp++; break;
                  case 80 : if (nula)  kDown++; break;
                  case 'e' : bE++; break;
                  case 'c' : bC++; break;
                  case 'p' : bP++; break;
                  case 's' : bS++; break;
                  case 'v' : bV++; break;
                  case 'k' : bK++; break;
                  case 'i' : bI++; break;
                  case 'd' : bD++; break;
                  case 'q' : bQ++; break;
                  case 'u' : bU++; break;
                  case 'j' : bJ++; break;
                  case 'n' : bN++; break;
                  case 'r' : bR++; break;
                  case 'm' : bM++; break;
                  case 'o' : bO++; break;
                  case 59 : if (nula) bF1++; break;
                  case 27 : bEsc++; break;
                }//switch
  }//if
  MouseEvents ();
  if (kTab) {
   kTab--; selected++;
   if (selected > 2) selected = 0;
   Relace[selected].Focus ();
  }//if
  if (bStar) { bStar--; Beep (ClickFreq, ClickDelay); SetDimension (); }//if
  if (kLeft) { kLeft--; Relace[selected].Move (-1, 0, 1); }//if
  if (kRight) { kRight--; Relace[selected].Move (1, 0, 1); }//if
  if (kUp) { kUp--; Relace[selected].Move (0, -1, 1); }//if
  if (kDown) { kDown--; Relace[selected].Move (0, 1, 1); }//if
  if (bE) { bE--; Beep (ClickFreq, ClickDelay); Relace[selected].Edit (); }//if
  if (bC) { bC--; Beep (ClickFreq, ClickDelay); Copy (); }//if
  if (bP) {
   bP--; Beep (ClickFreq, ClickDelay);
   if (Copying) Paste ();
  }//if
  if (bS) { bS--; Beep (ClickFreq, ClickDelay); Relace[selected].Vynulovat (); }//if
  if (bV) { bV--; Beep (ClickFreq, ClickDelay); Exchange (); }//if
  if (bK) { bK--; Beep (ClickFreq, ClickDelay); Relace[selected].Komplementarni (); }//if
  if (bI) { bI--; Beep (ClickFreq, ClickDelay); Relace[selected].Inverzni (); }//if
  if (bD) {
   bD--; Beep (ClickFreq, ClickDelay); Relace[selected].Inverzni (); Relace[selected].Komplementarni ();
  }//if
  if (bQ) { bQ--; Beep (ClickFreq, ClickDelay); Relace[selected].Kvaziordinalni ();}//if
  if (bU) { bU--; Beep (ClickFreq, ClickDelay); Relace[selected].Puvodni (); }//if
  if (bJ) { bJ--; Beep (ClickFreq, ClickDelay); Sjednoceni (); }//if
  if (bN) { bN--; Beep (ClickFreq, ClickDelay); Prunik (); }//if
  if (bR) { bR--; Beep (ClickFreq, ClickDelay); Rozdil (); }//if
  if (bM) { bM--; Beep (ClickFreq, ClickDelay); SymRozdil (); }//if
  if (bO) { bO--; Beep (ClickFreq, ClickDelay); Kompozice (); }//if
  if (bF1) { bF1--; Beep (ClickFreq, ClickDelay); Napoveda (); }//if
  if (bEsc) Beep (ClickFreq, ClickDelay);
  //ScrollTitle ();
 } while (!bEsc);
}//EventHandler

void main ()
{
 clrscr ();
 int key, Continue = 1;
 printf ("Inicializace mysi ... ");
 if (!Mouse.Init ()) {
  printf ("\r\n  Chyba : Neni nainstalovan ovladac mysi ! Pokracovat bez ni ? (a/n)\r\n");
  do {
   fflush (stdin);
   key = getch ();
   if (!key) key = getch ();
   if (key == 'n') Continue = 0;
  } while ((key != 'a') && (key != 'n'));
 }//if
 else printf ("OK");
 if (!Continue) exit (1);
 printf ("\r\nInicializace grafiky ... ");
 int gdriver = DETECT, gmode, errorcode;
 initgraph (&gdriver, &gmode, ".");
 errorcode = graphresult ();
 if (errorcode != grOk) { /* an error occurred */
  printf ("\r\n  Chyba grafiky : %s\r\n", grapherrormsg (errorcode));
  exit (1);             /* return with error code */
 }//if
 GraphOn = 1;
 DrawMain ();
 DrawButtons ();
 Mouse.Display ();
 EventHandler ();
 closegraph ();
 clrscr ();
 printf ("Program RELACE je zapocet z predmetu Logika a teorie mnozin.\r\n\r\n"
         "Dekuji za jeho pouziti !\r\n\r\n"
         "Jan Outrata - student Univerzity Palackeho, oboru Informatika\r\n"
         "            - e-mail: outrataj@inf.upol.cz\r\n"
         "1999\r\n");
}//main